%bcond_without qmail
%define pkgname qmail-services
%define pkgver 0.0.7

Name:           %{pkgname}
Version:        %{pkgver}
Release:        1%{?dist}
Summary:        Provides additional qmail services using supervise run scripts (i.e. msad, smtpd, smtpsd ...)
URL:            http://choon.net/qmail-services.php
License:        GPL
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source0:        http://choon.net/opensource/%{name}-%{version}.tar.bz2
Requires:       qmail >= 1.03-37
Requires:       vmailmgr >= 0.97
Requires:       vmailmgr-daemon >= 0.97
Requires:       vmailmgr-dovecot-wrapper >= 0.97
Requires:       cvm >= 0.96
Requires:       mailfront >= 2.22
Requires:       ucspi-tcp >= 0.88
Requires:       daemontools >= 0.76
Requires:       supervise-scripts >= 4.0-2
Requires:       openssl
Requires:       make
Requires:       /bin/sh
Requires:       greetdelay >= 0.04
Requires:       qmail-queue-repair >= 0.9.0
Requires:       mailfront-plugin-add-track-auth-sender >= 0.02
Requires:       mailfront-plugin-check-helo >= 0.02
Requires:       mailfront-plugin-add-track-auth-sender >= 0.01
Requires:       mailfront-plugin-check-dnsbl >= 0.01
Requires:       mailfront-plugin-remotehost >= 0.03-2
Requires:       relay-ctrl >= 3.2-2
Requires:       hostname
# Needed by /usr/bin/getent
Requires:       glibc-common
Requires:       python36u-certbot
Requires:       dovecot
BuildRequires:  make
%if %{with qmail}
BuildRequires:  qmail >= 1.03-30
%endif
BuildRequires:  systemd
BuildRequires:  ucspi-tcp >= 0.88
BuildArch:      noarch

%description
Manage and provides the following qmail services using supervise run scripts
with vmailmgr, mailfront, cvm and ucspi-tcp:

    msad          - Mail Submission Agent Daemon
    smtpd         - SMTP Daemon
    smtpsd        - SMTP over SSL Daemon
    qmtpd         - Quick Mail Transport Protocol Daemon
    cvm-chain     - Multi-module chaining shim Daemon
                    (http://untroubled.org/cvm/cvm-chain.html)
    cvm-vmailmgr  - CVM module for vmailmgr Daemon
                    (http://untroubled.org/cvm/cvm-vmailmgr.html)
    vmailmgrd-tcp - vmailmgrd over TCP Daemon

%package source
Requires: %{name} = %{version}-%{release}
Summary: Source files for qmail-services
Group: Development/Libraries
%description source
This package provides the source files for qmail-services.


%prep

%setup -q

%build
# Nothing to do

%install

rm -rf %{buildroot}

make install PREFIX=%{buildroot}
pushd %{buildroot}
    install -d etc/tcpcontrol
popd
pushd %{buildroot}/etc/tcpcontrol
    echo :allow > msa.rules
    echo :allow > qmtp.rules
    echo :allow > smtp.rules
    echo :allow > smtps.rules
    echo :allow > vmailmgr.rules
    tcprules msa.cdb msa.tmp < msa.rules
    tcprules qmtp.cdb qmtp.tmp < qmtp.rules
    tcprules smtp.cdb smtp.tmp < smtp.rules
    tcprules smtps.cdb smtps.tmp < smtps.rules
    tcprules vmailmgr.cdb vmailmgr.tmp < vmailmgr.rules
popd

for eachsvc in cvm-chain cvm-vmailmgr msad qmtpd smtpd smtpsd; do
    mkdir -p %{buildroot}/var/qmail/conf.d/$eachsvc
done

echo 30000000 > %{buildroot}/var/qmail/conf.d/cvm-chain/ulimitdata
echo 30000000 > %{buildroot}/var/qmail/conf.d/cvm-vmailmgr/ulimitdata
echo 90000000 > %{buildroot}/var/qmail/conf.d/msad/ulimitdata
echo 90000000 > %{buildroot}/var/qmail/conf.d/qmtpd/ulimitdata
echo 90000000 > %{buildroot}/var/qmail/conf.d/smtpd/ulimitdata
echo 90000000 > %{buildroot}/var/qmail/conf.d/smtpsd/ulimitdata
touch %{buildroot}/var/qmail/conf.d/msad/env
touch %{buildroot}/var/qmail/conf.d/smtpd/env
touch %{buildroot}/var/qmail/conf.d/smtpsd/env


%pre
# install       upgrade         uninstall
# $1 == 1       $1 == 2         (N/A)
#export PATH="/var/qmail/bin:/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/sbin:/usr/local/bin"

svc_down() {
    local myname=$1
    local mydir=${2:-/service}
    local checkisup=""
    local checklogisup=""
    local myreturn=0
    if [ -n "$myname" ] && [ -n "$mydir" ] ; then
        if [ -h "${mydir}/${myname}" ] ; then
            myreturn=1
            svc-stop ${myname}
            sleep 1
            echo -n "Waiting for ${myname} to be down ... "
            checkisup=`svstat ${mydir}/${myname} | grep ': up'`
            while [ -n "$checkisup" ]
            do
                sleep 1
                echo -n "."
                checkisup=`svstat ${mydir}/${myname} | grep ': up'`
            done
            echo " done."
            myreturn=0
        fi
    fi
    return $myreturn
}

# Before doing anything we need to make sure the following services are down:
# - cvm-chain
# - cvm-vmailmgr
# - msad
# - qmtpd
# - smtpd
# - smtpsd
# - vmailmgrd-tcp
for eachsvc in cvm-chain cvm-vmailmgr msad qmtpd smtpd smtpsd vmailmgrd-tcp; do
    svc_down $eachsvc
done

exit 0


%post
# install       upgrade         uninstall
# $1 == 1       $1 == 2         (N/A)

#export PATH="/var/qmail/bin:/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/sbin:/usr/local/bin"

%{_bindir}/maketcprules
%{_sbindir}/choon-mail-certbot init

exit 0


%preun
# install       upgrade         uninstall
# (N/A)         $1 == 1          $1 == 0

mystatus="$1"

#export PATH="/var/qmail/bin:/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/sbin:/usr/local/bin"

if [ "$mystatus" -eq 0 ] ; then
    for eachsvc in cvm-chain cvm-vmailmgr msad qmtpd smtpd smtpsd vmailmgrd-tcp; do
        if [ -f "%{_unitdir}/${eachsvc}.service" ] ; then
            systemctl disable ${eachsvc}.service || :
            systemctl stop ${eachsvc}.service || :
        fi
        if [ -h "/service/${eachsvc}" ] ; then
            svc-remove ${eachsvc}
        fi
    done
fi

exit 0

%postun
# install       upgrade         uninstall
# (N/A)         $1 == 1         $1 == 0
mystatus="$1"

if [ "$mystatus" -eq 0 ] ; then
    systemctl daemon-reload
fi

exit 0


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root)
%doc README

%config(noreplace) /etc/tcpcontrol/msa.cdb
%config(noreplace) /etc/tcpcontrol/qmtp.cdb
%config(noreplace) /etc/tcpcontrol/smtp.cdb
%config(noreplace) /etc/tcpcontrol/smtps.cdb
%config(noreplace) /etc/tcpcontrol/vmailmgr.cdb

%config(noreplace) /etc/tcpcontrol/msa.rules
%config(noreplace) /etc/tcpcontrol/qmtp.rules
%config(noreplace) /etc/tcpcontrol/smtp.rules
%config(noreplace) /etc/tcpcontrol/smtps.rules
%config(noreplace) /etc/tcpcontrol/vmailmgr.rules

%attr(1755,root,qmail) %dir /var/qmail/service/cvm-chain
%attr(1755,root,qmail) %dir /var/qmail/service/cvm-chain/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/cvm-chain/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/cvm-chain/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/cvm-vmailmgr
%attr(1755,root,qmail) %dir /var/qmail/service/cvm-vmailmgr/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/cvm-vmailmgr/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/cvm-vmailmgr/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/vmailmgrd-tcp
%attr(1755,root,qmail) %dir /var/qmail/service/vmailmgrd-tcp/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/vmailmgrd-tcp/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/vmailmgrd-tcp/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/msad
%attr(1755,root,qmail) %dir /var/qmail/service/msad/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/msad/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/msad/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/qmtpd
%attr(1755,root,qmail) %dir /var/qmail/service/qmtpd/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/qmtpd/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/qmtpd/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/smtpd
%attr(1755,root,qmail) %dir /var/qmail/service/smtpd/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/smtpd/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/smtpd/log/run
%attr(1755,root,qmail) %dir /var/qmail/service/smtpsd
%attr(1755,root,qmail) %dir /var/qmail/service/smtpsd/log
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/smtpsd/run
%attr(0755,root,qmail) %config(noreplace) /var/qmail/service/smtpsd/log/run
%attr(0750,root,root) %{_sbindir}/qmailctl
%attr(0750,root,root) %{_sbindir}/choon-mail-certbot

%attr(1750,qmaild,qmail) /var/qmail/ssl
%ghost %attr(0640,root,qmail) %config(noreplace) /var/qmail/service/CVM_LOOKUP_SECRET
%attr(0755,root,root) %dir /var/qmail/conf.d
%attr(0755,root,root) %dir /var/qmail/conf.d/*
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/msad/mailfront-plugins
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/qmtpd/mailfront-plugins
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/smtpd/mailfront-plugins
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/smtpsd/mailfront-plugins
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/cvm-chain/ulimitdata
%attr(0644,root,root) %config(noreplace) /var/qmail/conf.d/cvm-vmailmgr/ulimitdata
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/msad/ulimitdata
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/qmtpd/ulimitdata
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/smtpd/ulimitdata
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/smtpsd/ulimitdata
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/msad/env
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/smtpd/env
%attr(0640,root,qmail) %config(noreplace) /var/qmail/conf.d/smtpsd/env

%attr(0644,root,root) %{_unitdir}/*

%attr(0750,qmaill,nofiles) %dir /var/log/*


%changelog
* Tue Jul 30 2019 Giam Teck Choon <choonrpms@choon.net> - 0.0.6-1
- Update to 0.0.6

* Fri Apr 05 2019 Giam Teck Choon <choonrpms@choon.net> - 0.0.5-1
- Update to 0.0.5

* Thu Mar 07 2019 Giam Teck Choon <choonrpms@choon.net> - 0.0.4-1
- Update to 0.0.4

* Tue Jul 04 2017 Giam Teck Choon <choon@choon.net> - 0.0.3-2
- Add Requires: mailfront-plugin-remotehost >= 0.03-2
- Add Requires: relay-ctrl >= 3.2-2
- Set BuildArch: noarch
- Remove Group

* Tue Jul 04 2017 Giam Teck Choon <choon@choon.net> - 0.0.3-1
- Remove vmailmgrd related support
- Add systemd support
- Remove sysvinit scripts

* Wed Nov 09 2016 Giam Teck Choon <choonrpms@choon.net> - 0.0.2-1
- Double softlimit for cvm-chain and cvm-vmailmgr
- chown -R qmail:nofiles /var/log/vmailmgrd in post install
- Use softlimit without specify full path in cvm-chain and cvm-vmailmgr run
  files
- Bump to version 0.0.2

* Fri Sep 02 2016 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-16
- Add exclude /var/log/vmailmgrd as it causes conflict with vmailmgr-daemon

* Mon Aug 05 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-15
- Bump Requires: qmail >= 1.03-37
- Add qmtpd support

* Fri Aug 02 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-14%{?dist}
- Remove recordio and fixcrio in msad svc run script which missed previously

* Fri Aug 02 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-13%{?dist}
- Remove recordio and fixcrio in all smtpd/smtpsd run scripts

* Sun Jul 21 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-12%{?dist}
- Remove Requires: mailfront-plugin-policyd >= 0.02-5
- Remove Requires: mailfront-plugin-remotehost >= 0.02-2
- Remove Requires: mailfront-plugin-rblcheck >= 0.01-2
- Remove Requires: ipsvd >= 1.0.0
- Add force-restart and force-stop option in qmail init script
- Remove %%verify(md5 size mtime) for all svc run scripts

* Wed Jul 17 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-11
- Add %%verify(md5 size mtime) for all svc run scripts

* Wed Jul 17 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-10
- Set sslserver with -y option for imapd, pop3d and smtpd svc run scripts

* Sat Jul 13 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-9
- Set Requires: ucspi-ssl >= 0.70-2

* Mon Jun 10 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-8
- Add check-dnsbl into conf.d/smtpd/mailfront-plugins
- Add add-track-auth-sender into conf.d/smtpsd/mailfront-plugins
- Add add-track-auth-sender into conf.d/msad/mailfront-plugins
- Add Requires mailfront-plugin-check-dnsbl >= 0.01

* Tue May 28 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-7
- Add add-track-auth-sender and check-helo into conf.d/smtpd/mailfront-plugins
- Add include env file to export if found for svc run scripts
  (imapd, imapsd, msad, pop3d, pop3sd, smtpd, smtpsd)
- Add Requires mailfront-plugin-add-track-auth-sender >= 0.02
- Add Requires mailfront-plugin-check-helo >= 0.02

* Sat May 11 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-6
- Redo better handling in %%pre, %%post and %%postun
- Add fix_perm function in %%post to fix files permission in qmail queue todo,
  intd and mess folders
- Add export of variable MAXAUTHFAIL in imapd and imapsd run scripts
- Add export of variables MAXUSERCMD and MAXAUTHFAIL in pop3d and pop3sd run
  scripts
- Add export of variables TRACK_AUTH_SENDER_HEADER and TRACK_AUTH_SENDER in
  smtpd, smtpsd and msad run scripts

* Tue May 07 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-5
- Add svc-add and svc-start for vmailmgrd if no symlink found in /service in
  %%post

* Mon May 06 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-4
- Add missing require-auth in mailfront-plugins in conf.d/smtpsd
- Add Requires mailfront-plugin-add-track-auth-sender

* Tue Apr 30 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-3
- Add /var/qmail/control/logger file check in %%post

* Mon Apr 29 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-2
- Add various /etc/vmailmgr files check in %%post

* Sun Apr 28 2013 Giam Teck Choon <choonrpms@choon.net> - 0.0.1-1
- Initial release
